Leetcode 264 求第k个丑数 (偏数学的题目)

Leetcode 264 求第k个丑数 (偏数学的题目)_第1张图片

 

显然,如果一个数一个数的判断,直到n个,这个时间复杂度为O(nlogn), 不是面试管满意的答案。

优化的方法就是直接计算出第k丑数,显然可以通过枚举2,3,5因子的个数来计算丑数。但这样的枚举并不能保证顺序性,最容易想到的方法是借助一个最小堆来优化,每次求出当前最小的丑数,注意,此时还需要借助hashset来去重

typedef long long LL;
class Solution {
public:
    int nthUglyNumber(int n) {
        priority_queue,greater> q;
        q.push(1);
        unordered_set hashset;
        hashset.insert(1);
        LL nums[] = {2,3,5};
        while(--n){
            int tmp = q.top();q.pop();
            for(int i=0;i<3;i++){
                if(!hashset.count(tmp*nums[i])){
                    hashset.insert(tmp*nums[i]);
                    q.push(tmp*nums[i]);
                }
            }
        }
        return (int)q.top();
    }
};

如何保证枚举2,3,5因子乘出来的有序性?

如果只维护第k个丑数,是不行的。如果将前n个丑数全部存下来,这样处理,时间复杂度O(N)

class Solution {
public:
    int nthUglyNumber(int n) {
        vector dp(n);
        dp[0] = 1;
        int index2=0, index3=0,index5=0;
        for(int i=1;i

 

 

你可能感兴趣的:(算法)